# Refund a credit memo Note: This operation is only available if you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information. Refunds a full or partial posted credit memo to your customers. Only the amount of unapplied part could be refunded. You can refund a credit memo only if you have the user permission. See Billing Roles for more information. When you refund a credit memo, the total number of credit memo items to be refunded must be less than or equal to 15,000. For a use case of this operation, see Refund processing. Endpoint: POST /v1/credit-memos/{creditMemoKey}/refund Version: 2026-02-20 Security: bearerAuth ## Header parameters: - `Idempotency-Key` (string) Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident. - `Accept-Encoding` (string) Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it. - `Content-Encoding` (string) Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload. - `Zuora-Track-Id` (string) A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote ('). - `Zuora-Entity-Ids` (string) An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header. - `Zuora-Org-Ids` (string) Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs. - `Zuora-Version` (string) The minor API version. For a list of available minor versions, see API upgrades. ## Path parameters: - `creditMemoKey` (string, required) The ID or number of the credit memo. For example, 2c92c8955bd63cc1015bd7c151af02ab or CM00000001. ## Request fields (application/json): - `comment` (string) Comments about the refund. - `customRates` (array) It contains Home currency and Reporting currency custom rates currencies. The maximum number of items is 2 (you can pass the Home currency item, Reporting currency item, or both). Note: - This field is available only if you are on the latest Zuora API version, or you set the Zuora-Version request header to 224.0 or a later version. - You cannot set the custom rates, if both the Automatically include additional Currency Conversion information in data source exports option and Fx data feature are enabled. - `customRates.currency` (string, required) The currency code for either Reporting or Home currency. Note: This field is available only if you are on the latest Zuora API version, or you set the Zuora-Version request header to 224.0 or [a later available version](https://developer.zuora.com/v1-api-reference/api-versions/#minor-version). - `customRates.customFxRate` (number, required) The Custom FX conversion rate between Home/Reporting and Transactional currency items. Note: This field is available only if you are on the latest Zuora API version, or you set the Zuora-Version request header to 224.0 or [a later available version](https://developer.zuora.com/v1-api-reference/api-versions/#minor-version). - `customRates.rateDate` (string) The date on which a particular currency rate is fixed or obtained on. Note: This field is available only if you are on the latest Zuora API version, or you set the Zuora-Version request header to 224.0 or [a later available version](https://developer.zuora.com/v1-api-reference/api-versions/#minor-version). - `financeInformation` (object) Container for the finance information related to the refund. - `financeInformation.bankAccountAccountingCode` (string) The accounting code that maps to a bank account in your accounting system. - `financeInformation.onAccountAccountingCode` (string) The accounting code that maps to an on account in your accounting system. - `financeInformation.transferredToAccounting` (string) Whether the refund was transferred to an external accounting system. Use this field for integration with accounting systems, such as NetSuite. Enum: "Processing", "Yes", "No", "Error", "Ignore" - `financeInformation.unappliedPaymentAccountingCode` (string) The accounting code for the unapplied payment. - `gatewayId` (string) The ID of the gateway instance that processes the refund. This field can be specified only for electronic refunds. The ID must be a valid gateway instance ID, and this gateway must support the specific payment method. If no gateway ID is specified, the default gateway in the billing account configuration will be used. If no gateway is specified in the billing account, the default gateway of the corresponding tenant will be used. - `gatewayOptions` (object) The field used to pass gateway-specific parameters and parameter values. - `gatewayOptions.key` (string) The name of a gateway-specific parameter. - `gatewayOptions.value` (string) The value of the gateway-specific parameter. - `items` (array) Container for credit memo items. The maximum number of items is 1,000. Note: This field is only available if you have the [Invoice Item Settlement](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/C_Invoice_Item_Settlement) feature enabled. Invoice Item Settlement must be used together with other Invoice Settlement features (Unapplied Payments, and Credit and Debit memos). If you wish to enable Invoice Settlement, see [Invoice Settlement Enablement and Checklist Guide](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/Invoice_Settlement_Migration_Checklist_and_Guide) for more information. - `items.amount` (number, required) The amount of the refund on the specific item. - `items.creditMemoItemId` (string) The ID of the credit memo item that is refunded. - `items.creditTaxItemId` (string) The ID of the credit memo taxation item that is refunded. - `methodType` (string) How an external refund was issued to a customer. This field is required for an external refund and must be left empty for an electronic refund. You can issue an external refund on a credit memo. Enum: "ACH", "Cash", "Check", "CreditCard", "PayPal", "WireTransfer", "DebitCard", "CreditCardReferenceTransaction", "BankTransfer", "Other" - `paymentMethodId` (string) The ID of the payment method used for the refund. This field is required for an electronic refund, and the value must be an electronic payment method ID. This field must be left empty for an external refund. Example: "8ad084db90a5e73b0190c02783f552fa" - `reasonCode` (string) A code identifying the reason for the transaction. The value must be an existing reason code or empty. If you do not specify a value, Zuora uses the default reason code. - `referenceId` (string) The transaction ID returned by the payment gateway for an electronic refund. Use this field to reconcile refunds between your gateway and Zuora Payments. - `refundDate` (string) The date when the refund takes effect, in yyyy-mm-dd format. The date of the refund cannot be before the credit memo date. Specify this field only for external refunds. Zuora automatically generates this field for electronic refunds. - `secondRefundReferenceId` (string) The transaction ID returned by the payment gateway if there is an additional transaction for the refund. Use this field to reconcile payments between your gateway and Zuora Payments. - `softDescriptor` (string) A payment gateway-specific field that maps to Zuora for the gateways, Orbital, Vantiv and Verifi. - `softDescriptorPhone` (string) A payment gateway-specific field that maps to Zuora for the gateways, Orbital, Vantiv and Verifi. - `totalAmount` (number, required) The total amount of the refund. The amount cannot exceed the unapplied amount of the associated credit memo. If the original credit memo was applied to one or more invoices or debit memos, you have to unapply a full or partial credit memo from the invoices or debit memos, and then refund the full or partial unapplied credit memo to your customers. Example: 10 - `type` (string, required) The type of the refund. Enum: "External", "Electronic" - `IntegrationId__NS` (string) ID of the corresponding object in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). - `IntegrationStatus__NS` (string) Status of the refund's synchronization with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). - `Origin__NS` (string) Origin of the corresponding object in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). - `SyncDate__NS` (string) Date when the refund was synchronized with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). - `SynctoNetSuite__NS` (string) Specifies whether the refund should be synchronized with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). ## Response 200 fields (application/json): - `accountId` (string) The ID of the account associated with this refund. Zuora associates the refund automatically with the account from the associated payment. - `amount` (number) The total amount of the refund. - `cancelledOn` (string,null) The date and time when the refund was cancelled, in yyyy-mm-dd hh:mm:ss format. - `comment` (string,null) Comments about the refund. - `createdById` (string) The ID of the Zuora user who created the refund. - `createdDate` (string) The date and time when the refund was created, in yyyy-mm-dd hh:mm:ss format. For example, 2017-03-06 15:31:10. - `creditMemoId` (string) The ID of the credit memo that is refunded. - `financeInformation` (object) Container for the finance information related to the refund. - `financeInformation.bankAccountAccountingCode` (string,null) The accounting code that maps to a bank account in your accounting system. - `financeInformation.bankAccountAccountingCodeType` (string,null) The type of the accounting code that maps to a bank account in your accounting system. - `financeInformation.transferredToAccounting` (string,null) Whether the refund was transferred to an external accounting system. Use this field for integration with accounting systems, such as NetSuite. Enum: "Processing", "Yes", "No", "Error", "Ignore" - `financeInformation.unappliedPaymentAccountingCode` (string,null) The accounting code for the unapplied payment. - `financeInformation.unappliedPaymentAccountingCodeType` (string,null) The type of the accounting code for the unapplied payment. - `gatewayId` (string) The ID of the gateway instance that processes the refund. - `gatewayResponse` (string) The message returned from the payment gateway for the refund. This message is gateway-dependent. - `gatewayResponseCode` (string) The response code returned from the payment gateway for the refund. This code is gateway-dependent. - `gatewayState` (string) The status of the refund in the gateway. Enum: "MarkedForSubmission", "Submitted", "Settled", "NotSubmitted", "FailedToSettle" - `id` (string) The ID of the created refund. - `markedForSubmissionOn` (string,null) The date and time when a refund was marked and waiting for batch submission to the payment process, in yyyy-mm-dd hh:mm:ss format. - `methodType` (string) How an external refund was issued to a customer. Enum: "ACH", "Cash", "Check", "CreditCard", "PayPal", "WireTransfer", "DebitCard", "CreditCardReferenceTransaction", "BankTransfer", "Other" - `number` (string) The unique identification number of the refund. - `organizationLabel` (string) The organization that this object belongs to. Note: This field is available only when the Multi-Org feature is enabled. - `paymentId` (string,null) The ID of the payment associated with the refund. - `paymentMethodId` (string) The unique ID of the payment method that the customer used to make the refund. - `paymentMethodSnapshotId` (string) The unique ID of the payment method snapshot, which is a copy of the particular payment method used in a transaction. - `reasonCode` (string,null) A code identifying the reason for the transaction. - `referenceId` (string) The transaction ID returned by the payment gateway for an electronic refund. Use this field to reconcile refunds between your gateway and Zuora Payments. - `refundDate` (string) The date when the refund takes effect, in yyyy-mm-dd format. - `refundTransactionTime` (string) The date and time when the refund was issued, in yyyy-mm-dd hh:mm:ss format. - `secondRefundReferenceId` (string,null) The transaction ID returned by the payment gateway if there is an additional transaction for the refund. Use this field to reconcile payments between your gateway and Zuora Payments. - `settledOn` (string,null) The date and time when the refund was settled in the payment processor, in yyyy-mm-dd hh:mm:ss format. This field is used by the Spectrum gateway only and not applicable to other gateways. - `softDescriptor` (string,null) A payment gateway-specific field that maps to Zuora for the gateways, Orbital, Vantiv and Verifi. - `softDescriptorPhone` (string,null) A payment gateway-specific field that maps to Zuora for the gateways, Orbital, Vantiv and Verifi. - `status` (string) The status of the refund. Enum: "Processed", "Canceled", "Error", "Processing" - `submittedOn` (string) The date and time when the refund was submitted, in yyyy-mm-dd hh:mm:ss format. - `success` (boolean) Returns true if the request was processed successfully. - `type` (string) The type of the refund. Enum: "External", "Electronic" - `updatedById` (string) The ID of the Zuora user who last updated the refund. - `updatedDate` (string) The date and time when the refund was last updated, in yyyy-mm-dd hh:mm:ss format. For example, 2017-03-07 15:36:10. - `IntegrationId__NS` (string) ID of the corresponding object in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). - `IntegrationStatus__NS` (string) Status of the refund's synchronization with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). - `Origin__NS` (string) Origin of the corresponding object in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). - `SyncDate__NS` (string) Date when the refund was synchronized with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). - `SynctoNetSuite__NS` (string) Specifies whether the refund should be synchronized with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). ## Response 500 fields (application/json): - `reasons` (array) Example: [{"code":"ObjectNotFound","message":"Notification definition with id 6e569e1e05f040eda51a927b140c0ac1 does not exist"}] - `reasons.code` (string) The error code of response. - `reasons.message` (string) The detail information of the error response ## Response 4XX fields (application/json): - `processId` (string) The ID of the process that handles the operation. - `reasons` (array) The container of the error code and message. This field is available only if the success field is false. - `reasons.code` (string) The error code of response. - `reasons.message` (string) The detail information of the error response - `requestId` (string) Unique identifier of the request. - `success` (boolean) Indicates whether the call succeeded.